<bugID>1374216<Summary>Add-on icons should be in the navbar by first paint</Summary><Description>STR:

1. start nightly.


AR:
Additional button icons appear a second or so after the window comes up, creating distracting visual movement, not just for the icons but also for the location bar and search bar which resize based on the available space.

ER:
The window should be static after appearing. Icons for add-ons should appear in the toolbar immediately.


This is a regression because it used to work like this. My understanding is that we've delayed the startup of various bits to avoid some number of ms of startup costs, but it feels like the net result is now that startup looks messy, and essentially worse.

It's not really clear to me why we technically can't make this work. Seems like the simplest thing would be to require add-ons and their browser_actions to be loaded and ready by the time we first paint the window. 

If that is somehow impossible, a compromise could potentially be to have CustomizableUI *generate* the toolbarbuttons / widgets based on previous runtime, and hook up actual functionality when the add-on comes up. Assuming that at least the resource: URIs for the relevant icons are available immediately, that could be cheaper, and users would be none the wiser. My understanding is that in a webextension world, the toolbar buttons don't get notified for their instances being created nor do they have the possibility of manipulating the XUL button, so in principle this seems like it would be OK?

Andrew or Dave, do you have more context / thoughts here?</Description></bugID>